"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_to_regexp_1 = require("path-to-regexp");
const router_1 = require("./router");
class Route {
    constructor(method, path, handler, { exact = false } = {}) {
        this.keys = [];
        this.handle = (ctx) => __awaiter(this, void 0, void 0, function* () {
            return this.handleHandler(this.handler, ctx);
        });
        this.handleHandler = (handler, ctx) => __awaiter(this, void 0, void 0, function* () {
            if (handler instanceof router_1.Router) {
                return handler.handle(ctx);
            }
            else if (Array.isArray(handler)) {
                for (let index = 0; index < handler.length; index++) {
                    const childHandler = handler[index];
                    const returned = yield this.handleHandler(childHandler, ctx);
                    if (index === handler.length - 1) {
                        return returned;
                    }
                }
            }
            else {
                return handler(ctx);
            }
        });
        this.method = method;
        this.path = path;
        if (path) {
            this.regex = path_to_regexp_1.pathToRegexp(path, this.keys, { end: exact });
        }
        this.handler = handler;
    }
}
exports.Route = Route;
//# sourceMappingURL=route.js.map